import '@testing-library/jest-dom'

global.localStorage = {
  getItem: jest.fn(),
  setItem: jest.fn(),
  removeItem: jest.fn(),
  clear: jest.fn(),
};

const fakeClass = class {
  constructor(...args) {
    this.calledWith = args;
    this.listeners = new Map();
  }

  addListener = (name, fn) => {
    const list = this.listeners.get(name) ?? [];
    list.push(fn);
    this.listeners.set(name, list);
  }
}

global.google = {
  maps: {
    Geocoder: class extends fakeClass {
      geocode = jest.fn();
    },
    Polyline: fakeClass,
    Marker: fakeClass,
    Point: fakeClass,
    StreetViewPanorama: fakeClass,
  },
};

global.fetch = jest.fn();

jest.useFakeTimers();

window.open = jest.fn();